/*
This file parses a string into words and returns the result in an array
of strings. I'm tired of dealing with strtok and whatnot so I'm going
to do this once with re2c and do it right.

The returned pointer will point to a block of memory which contains
both the pointers and the strings. You can just free the returned
pointer to free everything.

Words are separated by whitespace. All whitespace characters are
eaten up by this function unless they occur within double quote
pairs. If something is given in double quotes, then the whole
double quoted text is taken to be a separate word.

Maybe later I can have a flag for this function to enable/disable
this quoting feature or to add new quoting characters.
*/
#include <stdlib.h>
#include <string.h>


char **split_words(char *src)
{
  int for_real= 0;
  char **ret;
  char *str_area;
  int nwords=0;
  char *cursor, *marker,*start;

  cursor= src;
  start= cursor;

again:
/*!re2c
  re2c:define:YYCURSOR= cursor;
  re2c:define:YYMARKER= marker;
  re2c:define:YYCTYPE= char;
  re2c:yyfill:enable= 0;
  Q=[\042];
  [\001-\040\177]+ { start= cursor; goto again; }
  Q[^\000"]*Q     { goto do_word; }
  [^\000\001-\040\177]+ { goto do_word; }
  [\000]           { goto do_eof; }
*/
do_word:
  if (for_real) {
    int L= cursor-start;
    memcpy(str_area, start, L);
    ret[nwords]= str_area;
    str_area[L]= 0;
    str_area+= L+1;
  } 
  nwords++;
  start= cursor;
  goto again; 
do_eof:
  if (for_real) { ret[nwords]= 0; return ret;}
  ret= (char**) malloc(nwords+strlen(src)+ sizeof(char*)*(nwords+1));
  str_area= (char*) ret + sizeof(char*)*(nwords+1);
  nwords= 0; for_real= 1;
  cursor= src; start= src;
  goto again;
}


